#include<bits/stdc++.h>
#define endl '\n'

typedef long long ll;
using namespace std;


void speed()
{
    std::ios_base::sync_with_stdio(false);
    std::cin.tie(nullptr);
    std::cin.tie(nullptr);
}

struct Point
{
    ll x, y;

    Point(ll _x = 0, ll _y = 0)
    {
        x = _x;
        y = _y;
    }
};

const int MAXN = 1e5 + 10;

int n, k;
Point dot[MAXN];

void input()
{
    std::cin >> n >> k;
    for (int i = 1; i <= n; i ++)
    {
        std::cin >> dot[i].x >> dot[i].y;
    }
}

const ll inf= 4e9;
std::pair < Point, ll > solve_k1(std::vector < Point > vec)
{
    ll min_x = inf, max_x = -inf, min_y = inf, max_y = -inf;
    int s = vec.size();
    for (int i = 0; i < s; i ++)
    {
        min_x = std::min(min_x, vec[i].x);
        max_x = std::max(max_x, vec[i].x);
        min_y = std::min(min_y, vec[i].y);
        max_y = std::max(max_y, vec[i].y);
    }

    ll side = std::max(max_x - min_x, max_y - min_y);
    if (side == 0)
        side = 1;
    return {Point(min_x, min_y), side};
    ///std::cout << min_x << " " << min_y << " " << side << endl;
}

bool cmp_x_less_y(Point p1, Point p2)
{
    if (p1.x != p2.x)
        return p1.x < p2.x;
    return p1.y < p2.y;
}

bool cmp_x_more_y(Point p1, Point p2)
{
    if (p1.x != p2.x)
        return p1.x < p2.x;
    return p1.y > p2.y;
}

bool cmp_y_less_x(Point p1, Point p2)
{
    if (p1.y != p2.y)
        return p1.y < p2.y;
    return p1.x < p2.x;
}
bool cmp_y_more_x(Point p1, Point p2)
{
    if (p1.y != p2.y)
        return p1.y < p2.y;
    return p1.x > p2.x;
}

ll get_value(std::vector < std::pair < Point, ll > > cur)
{
    ll mx = -inf;
    for (std::pair < Point, ll > ds : cur)
        mx = std::max(mx, ds.second);
    return mx;
}

ll pref[4][MAXN], suff[4][MAXN];
/*
0 - min_x
1 - max_x
2 - min_y
3 - max_y
*/

bool intersect(int l, int r, int x, int y)
{
    if (l > x)
    {
        swap(l, x);
        swap(r, y);
    }
    if (r >= x)
        return true;
    return false;

}
std::vector < std::pair < Point, ll > > try_split(std::vector < Point > vec, int type)
{
    int s = vec.size();
    assert(s > 0);

    pref[0][0] = vec[0].x;
    pref[1][0] = vec[0].x;
    pref[2][0] = vec[0].y;
    pref[3][0] = vec[0].y;

    for (int i = 1; i < s; i ++)
    {
        pref[0][i] = pref[0][i - 1];
        if (vec[i].x < pref[0][i])
            pref[0][i] = vec[i].x;
        pref[1][i] = pref[1][i - 1];
        if (vec[i].x > pref[1][i])
            pref[1][i] = vec[i].x;
        pref[2][i] = pref[2][i - 1];
        if (vec[i].y < pref[2][i])
            pref[2][i] = vec[i].y;
        pref[3][i] = pref[3][i - 1];
        if (vec[i].y > pref[3][i])
            pref[3][i] = vec[i].y;
    }

    suff[0][s - 1] = vec[s - 1].x;
    suff[1][s - 1] = vec[s - 1].x;
    suff[2][s - 1] = vec[s - 1].y;
    suff[3][s - 1] = vec[s - 1].y;

    for (int i = s - 2; i >= 0; i --)
    {
        suff[0][i] = suff[0][i + 1];
        suff[1][i] = suff[1][i + 1];
        suff[2][i] = suff[2][i + 1];
        suff[3][i] = suff[3][i + 1];
        if (vec[i].x < suff[0][i])
            suff[0][i] = vec[i].x;
        if (vec[i].x > suff[1][i])
            pref[1][i] = vec[i].x;
        if (vec[i].y < suff[2][i])
            suff[2][i] = vec[i].y;
        if (vec[i].y > suff[3][i])
            suff[3][i] = vec[i].y;
    }

    ll best = inf;
    int spl = -1;
    for (int i = 0; i < s - 1; i ++)
    {
        ll s1 = std::max(pref[1][i] - pref[0][i], pref[3][i] - pref[2][i]);
        ll s2 = std::max(suff[1][i + 1] - suff[0][i + 1], suff[3][i + 1] - suff[2][i + 1]);
        if (intersect(pref[0][i], pref[1][i], suff[0][i + 1], suff[1][i + 1]) &&
            intersect(pref[2][i], pref[3][i], suff[2][i + 1], suff[3][i + 1]))
            continue;
        if (std::max(s1, s2) < best)
        {
            best = std::max(s1, s2);
            spl = i;
        }
    }


    std::vector < std::pair < Point, ll > > ret;
        if (spl == -1)
        return ret;
    ll s1 = std::max(pref[1][spl] - pref[0][spl], pref[3][spl] - pref[2][spl]);
    ll s2 = std::max(suff[1][spl + 1] - suff[0][spl + 1], suff[3][spl + 1] - suff[2][spl + 1]);
    if(s1 == 0)
    s1 = 1;
    if(s2 == 0)
    s2 = 1;
    if (type == 0)
    {
        //ret.push_back(make_pair(Point(pref[1][spl] - s1, pref[3][spl] - s1), s1));
        //ret.push_back(make_pair(Point(suff[0][spl + 1], suff[2][spl + 1]), s2));
    }
    if (type == 1)
    {
        //ret.push_back(make_pair(Point(pref[1][spl] - s1, pref[3][spl]), s1));
        //ret.push_back(make_pair(Point(suff[0][spl + 1], suff[2][spl + 1] - s2), s2));
    }
    if (type == 2)
    {
        ret.push_back(make_pair(Point(pref[1][spl] - s1, pref[3][spl] - s1), s1));
        ret.push_back(make_pair(Point(suff[0][spl + 1], suff[2][spl + 1]), s2));
    }
    if (type == 3)
    {
        ret.push_back(make_pair(Point(pref[1][spl] - s1, pref[3][spl]), s1));
        ret.push_back(make_pair(Point(suff[0][spl + 1], suff[2][spl + 1] - s2), s2));
    }
    return ret;


}
std::vector < std::pair < Point, ll > > solve_k2(std::vector < Point > vec)
{
    std::vector < std::pair < Point, ll > > best, temp;
    sort(vec.begin(), vec.end(), cmp_x_less_y);
    best = try_split(vec, 0);
    sort(vec.begin(), vec.end(), cmp_x_more_y);
    temp = try_split(vec, 1);
    if (get_value(temp) < get_value(best))
        best = temp;
    sort(vec.begin(), vec.end(), cmp_y_less_x);
    temp = try_split(vec, 2);
    if (get_value(temp) < get_value(best))
        best = temp;
    sort(vec.begin(), vec.end(), cmp_y_more_x);
    temp = try_split(vec, 3);
    if (get_value(temp) < get_value(best))
        best = temp;

    return best;
}
void solve()
{
    input();
    std::vector < Point > vec;
    for (int i = 1; i <= n; i ++)
        vec.push_back(dot[i]);
    if (k == 1)
    {
        std::pair < Point, ll > res = solve_k1(vec);
        std::cout << res.first.x << " " << res.first.y << " " << res.second << endl;
        return;
    }

    if (k == 2) 
    {
        std::vector < std::pair < Point, ll > > res, two;
        res.push_back(solve_k1(vec));
        res.push_back({Point(-1e9, -1e9), 1});

        two = solve_k2(vec);
        if (!two.empty() && get_value(two) < get_value(res))
            res = two;
        for (pair < Point, ll > cur : res)
            cout << cur.first.x << " " << cur.first.y << " " << cur.second << endl;
    }
}

int main()
{
    speed();
    solve();
    return 0;
}
/*
3 2
0 0
1 1
2 2
*/