#include <algorithm>
#include <iostream>
#include <cassert>
#include <vector>
#include <map>
#include <set>

int randomImeKoetoNqmaDaPolzvam; // ✨✨✨✨
typedef long long llong;
const int MAXN = 1e5 + 10;
const int INF  = 2e9;

int n;
struct Point
{
    int x, y;
};

Point p[MAXN];
int prefMIN[MAXN];
int prefMAX[MAXN];
int suffMIN[MAXN];
int suffMAX[MAXN];

void solve()
{
    if (n == 1)
    {
        std::cout << (llong)(-3e9) << ' ' << (llong)(-3e9) << ' ' << 1 << '\n';
        std::cout << p[1].x << ' ' << p[1].y << ' ' << 1 << '\n';
        return;
    }

    std::sort(p + 1, p + 1 + n, [&](auto a, auto b)
    {
        return a.x < b.x;
    });

    int ans = INF;
    std::vector <std::array <llong,3>> sol(2);

    prefMIN[0] = suffMIN[n + 1] = INF;
    prefMAX[0] = suffMAX[n + 1] = -INF;
    
    for (int i = 1 ; i <= n ; ++i)
    {
        prefMIN[i] = std::min(prefMIN[i - 1], p[i].y);
        prefMAX[i] = std::max(prefMAX[i - 1], p[i].y);
    }

    for (int i = n ; i >= 1 ; --i)
    {
        suffMIN[i] = std::min(suffMIN[i + 1], p[i].y);
        suffMAX[i] = std::max(suffMAX[i + 1], p[i].y);
    }

    for (int i = 1 ; i + 1 <= n ; ++i)
    {
        if (p[i].x < p[i + 1].x)
        {
            int size = std::max(std::max(p[i].x - p[1].x, prefMAX[i] - prefMIN[i]), std::max(p[n].x - p[i + 1].x, suffMAX[i + 1] - suffMIN[i + 1]));
            if (size < ans)
            {
                ans = size;
                int leftSize = std::max(p[i].x - p[1].x, prefMAX[i] - prefMIN[i]);
                int rightSize = std::max(p[n].x - p[i + 1].x, suffMAX[i + 1] - suffMIN[i + 1]);
                sol[0] = {p[i].x - leftSize, prefMAX[i] - leftSize, leftSize};
                sol[1] = {p[i + 1].x, suffMIN[i + 1], rightSize};
            }
        }
    }

    std::sort(p + 1, p + 1 + n, [&](auto a, auto b)
    {
        return a.y < b.y;
    });

    prefMIN[0] = suffMIN[n + 1] = INF;
    prefMAX[0] = suffMAX[n + 1] = -INF;
    
    for (int i = 1 ; i <= n ; ++i)
    {
        prefMIN[i] = std::min(prefMIN[i - 1], p[i].x);
        prefMAX[i] = std::max(prefMAX[i - 1], p[i].x);
    }

    for (int i = n ; i >= 1 ; --i)
    {
        suffMIN[i] = std::min(suffMIN[i + 1], p[i].x);
        suffMAX[i] = std::max(suffMAX[i + 1], p[i].x);
    }

    for (int i = 1 ; i + 1 <= n ; ++i)
    {
        if (p[i].y < p[i + 1].y)
        {
            int size = std::max(std::max(p[i].y - p[1].y, prefMAX[i] - prefMIN[i]), std::max(p[n].y - p[i + 1].y, suffMAX[i + 1] - suffMIN[i + 1]));
            if (size < ans)
            {
                ans = size;
                int leftSize = std::max(p[i].y - p[1].y, prefMAX[i] - prefMIN[i]);
                int rightSize = std::max(p[n].y - p[i + 1].y, suffMAX[i + 1] - suffMIN[i + 1]);
                sol[0] = {prefMAX[i] - leftSize, p[i].y - leftSize, leftSize};
                sol[1] = {suffMIN[i + 1], p[i + 1].y, rightSize};
            }
        }
    }

    for (const auto &square : sol)
    {
        std::cout << square[0] << ' ' << square[1] << ' ' << square[2] << '\n';
    }
}

void input()
{
    std::cin >> n >> randomImeKoetoNqmaDaPolzvam;
    for (int i = 1 ; i <= n ; ++i)
    {
        std::cin >> p[i].x >> p[i].y;
    }
}

void fastIOI()
{
    std::ios_base :: sync_with_stdio(0);
    std::cout.tie(nullptr);
    std::cin.tie(nullptr);
}

int main()
{
    fastIOI();
    input();
    solve();

    return 0;
}