#include <algorithm>
#include <iostream>
#include <cassert>
#include <vector>
#include <map>
#include <set>

int randomImeKoetoNqmaDaPolzvam; // ✨✨✨✨
typedef long long llong;
const int MAXN = 1e5 + 10;
const int MAXB = 1 << 12;
const llong INF  = 1e18;
const int INTINF  = 2e9;

int n, k;
struct Point
{
    llong x, y;
};

Point p[MAXN];
int minMaskX[MAXB];
int minMaskY[MAXB];
int maxMaskX[MAXB];
int maxMaskY[MAXB];
std::array <llong,3> squares[MAXB][2];

inline bool ok(std::array <llong,3> first, std::array <llong,3> second)
{
    return std::max(first[0], second[0]) > std::min(first[0] + first[2], second[0] + second[2]) || std::max(first[1], second[1]) > std::min(first[1] + first[2], second[1] + second[2]);
}

void solve()
{
    for (int mask = 0 ; mask < (1 << n) ; ++mask)
    {
        llong minX = INF, minY = INF, maxX = -INF, maxY = -INF;
        for (int i = 1 ; i <= n ; ++i)
        {
            if (mask & (1 << i - 1))
            {
                minX = std::min(minX, p[i].x);
                maxX = std::max(maxX, p[i].x);
                minY = std::min(minY, p[i].y);
                maxY = std::max(maxY, p[i].y);
            }
        }

        minMaskX[mask] = minX;
        minMaskY[mask] = minY;
        maxMaskX[mask] = maxX;
        maxMaskY[mask] = maxY;

        if (maxX - minX < maxY - minY)
        {
            squares[mask][0] = {minX, minY, std::max(1LL, maxY - minY)};
            squares[mask][1] = {maxX - (maxY - minY), minY, std::max(1LL, maxY - minY)};
        } else
        {
            squares[mask][0] = {minX, minY, std::max(1LL, maxX - minX)};
            squares[mask][1] = {minX, maxY - (maxX - minX), std::max(1LL, maxX - minX)};
        }
    }    

    squares[0][0] = {(llong)-3e9, (llong)-3e9, 1};
    squares[0][1] = {(llong)-3e9, (llong)-3e9, 1};
    llong ans = INF;
    std::vector <std::array <llong,3>> sol(3);
    for (int mask1 = 1 ; mask1 < (1 << n) ; ++mask1)
    {
        for (int mask2 = 1 ; mask2 < (1 << n) ; ++mask2)
        {

            if (mask2 & mask1)
            {
                continue;
            }

            int mask3 = ((1 << n) - 1) ^ mask1 ^ mask2;
            for (int bit1 = 0 ; bit1 < 2 ; ++bit1)
            {
                for (int bit2 = 0 ; bit2 < 2 ; ++bit2)
                {
                    if (!ok(squares[mask1][bit1], squares[mask2][bit2]))
                    {
                        continue;
                    }

                    llong maxSize = std::max(std::max(squares[mask1][bit1][2], squares[mask2][bit2][2]), squares[mask3][0][2]);
                    if (maxSize >= ans)
                    {
                        continue;
                    }

                    if (ok(squares[mask1][bit1], squares[mask3][0]) && ok(squares[mask2][bit2], squares[mask3][0]))
                    {
                        ans = maxSize;
                        sol[0] = squares[mask1][bit1];
                        sol[1] = squares[mask2][bit2];
                        sol[2] = squares[mask3][0];
                        continue;
                    }

                    if (ok(squares[mask1][bit1], squares[mask3][1]) && ok(squares[mask2][bit2], squares[mask3][1]))
                    {
                        ans = maxSize;
                        sol[0] = squares[mask1][bit1];
                        sol[1] = squares[mask2][bit2];
                        sol[2] = squares[mask3][1];
                        continue;
                    }

                    if (maxMaskX[mask3] - minMaskX[mask3] < maxMaskY[mask3] - minMaskY[mask3])
                    {
                        llong upperBound = std::max(minMaskX[mask1], minMaskX[mask2]) - 1;
                        llong lowerBound = std::min(maxMaskX[mask1], maxMaskX[mask2]) + 1;
                        if (upperBound - lowerBound >= maxMaskY[mask3] - minMaskY[mask3])
                        {
                            std::array <llong,3> newSquare = {lowerBound, minMaskY[mask3], maxMaskY[mask3] - minMaskY[mask3]};
                            if (ok(squares[mask1][bit1], newSquare) && ok(squares[mask2][bit2], newSquare))
                            {
                                ans = maxSize;
                                sol[0] = squares[mask1][bit1];
                                sol[1] = squares[mask2][bit2];
                                sol[2] = newSquare;
                                continue;
                            }
                        }
                    } else
                    {
                        llong upperBound = std::max(minMaskY[mask1], minMaskY[mask2]) - 1;
                        llong lowerBound = std::min(maxMaskY[mask1], maxMaskY[mask2]) + 1;
                        if (upperBound - lowerBound >= maxMaskX[mask3] - minMaskX[mask3])
                        {
                            std::array <llong,3> newSquare = {minMaskX[mask3], lowerBound, maxMaskX[mask3] - minMaskX[mask3]};
                            if (ok(squares[mask1][bit1], newSquare) && ok(squares[mask2][bit2], newSquare))
                            {
                                ans = maxSize;
                                sol[0] = squares[mask1][bit1];
                                sol[1] = squares[mask2][bit2];
                                sol[2] = newSquare;
                                continue;
                            }
                        }
                    }
                }
            }
        }
    }

    // std::cout << "ans is: " << ans << '\n';
    for (int i = 0 ; i < sol.size() ; ++i)
    {
        std::cout << sol[i][0] << ' ' << sol[i][1] << ' ' << sol[i][2] << '\n';        
    }    
}

void input()
{
    std::cin >> n >> k;
    for (int i = 1 ; i <= n ; ++i)
    {
        std::cin >> p[i].x >> p[i].y;
    }
}

void fastIOI()
{
    std::ios_base :: sync_with_stdio(0);
    std::cout.tie(nullptr);
    std::cin.tie(nullptr);
}

int main()
{
    fastIOI();
    input();
    solve();

    return 0;
}