#include <algorithm>
#include <iostream>
#include <cassert>
#include <vector>
#include <map>
#include <set>

typedef long long llong;
const int MAXN = 5e5 + 10;
const llong INF  = 1e18;
const int INTINF  = 1e9;

int n;
int a[MAXN];
llong prefix[MAXN];
llong suffix[MAXN];

void solve()
{
    for (int i = 1 ; i <= n ; ++i)
    {
        if (a[i] == -1)
        {
            prefix[i] = prefix[i - 1];
            continue;
        }

        if (i == 1 || a[i - 1] != 1)
        {
            prefix[i] = INF;
            continue;
        }

        prefix[i] = prefix[i - 2] + 1;
    }

    for (int i = n ; i >= 1 ; --i)
    {
        if (a[i] == 1)
        {
            suffix[i] = suffix[i + 1];
            continue;
        }

        if (i == n || a[i + 1] != -1)
        {
            suffix[i] = INF;
            continue;
        }

        suffix[i] = suffix[i + 2] + 1;
    }

    llong ans = INF;
    for (int i = 0 ; i <= n ; ++i)
    {
        if (prefix[i] != INF && suffix[i + 1] != INF)
        {
            ans = std::min(ans, prefix[i] + suffix[i + 1]);
        }
    }

    if (ans == INF) std::cout << -1 << '\n';
    else std::cout << ans << '\n';
}

void input()
{
    std::cin >> n;
    for (int i = 1 ; i <= n ; ++i)
    {
        std::cin >> a[i];
    }
}

void fastIOI()
{
    std::ios_base :: sync_with_stdio(0);
    std::cout.tie(nullptr);
    std::cin.tie(nullptr);
}

int main()
{
    fastIOI();
    input();
    solve();

    return 0;
}