#include <algorithm>
#include <iostream>
#include <cassert>
#include <vector>
#include <map>
#include <set>

typedef long long llong;
const int MAXN = 5e5 + 10;
const llong INF  = 1e18;
const int INTINF  = 1e9;

int n;
int a[MAXN];
llong prefix[MAXN];
llong suffix[MAXN];

void solve()
{
    llong ans = INF;
    for (int split = 0 ; split <= n ; ++split)
    {
        llong curr = 0;
        bool isOK = true;
        bool holdingLeft = false;
        bool holdingRight = false;
        for (int i = 1 ; i <= split ; ++i)
        {
            if (!holdingLeft)
            {
                if (a[i] == -1)
                {
                    continue;
                }

                if (i + 1 <= split && a[i + 1] == 1)
                {
                    curr++;
                    i++;
                    continue;
                }

                holdingLeft = true;
            } else
            {
                if (a[i] == 1)
                {
                    curr++;
                    holdingLeft = false;
                    continue;
                }

                if (i == split || a[i + 1] == 1)
                {
                    isOK = false;
                    break;                    
                }

                curr += 2;
                i++;
            }
        }

        if (!isOK)
        {
            continue;
        }

        for (int i = n ; i > split ; --i)
        {
            if (!holdingRight)
            {
                if (a[i] == 1)
                {
                    continue;
                }

                if (i - 1 > split && a[i - 1] == -1)
                {
                    curr++;
                    i--;
                    continue;
                }

                holdingRight = true;
            } else
            {
                if (a[i] == -1)
                {
                    curr++;
                    holdingRight = false;
                    continue;
                }

                if (i - 1 == split || a[i + 1] == -1)
                {
                    isOK = false;
                    break;                    
                }

                curr += 2;
                i--;
            }
        }
        
        if (!isOK || (holdingLeft && holdingRight))
        {
            continue;
        }

        ans = std::min(ans, curr);
    }

    if (ans == INF) std::cout << -1 << '\n';
    else std::cout << ans << '\n';
}

void input()
{
    std::cin >> n;
    for (int i = 1 ; i <= n ; ++i)
    {
        std::cin >> a[i];
    }
}

void fastIOI()
{
    std::ios_base :: sync_with_stdio(0);
    std::cout.tie(nullptr);
    std::cin.tie(nullptr);
}

int main()
{
    fastIOI();
    input();
    solve();

    return 0;
}