#include <algorithm>
#include <iostream>
#include <cassert>
#include <vector>
#include <map>

#pragma GCC optimize ("O3")
#pragma GCC target ("sse4")

const int MAXN = 4e6 + 10;

std::map <std::vector <std::pair <std::pair <int,int>, std::pair <int,int>>>, int> map;
std::vector <std::pair <std::pair <int,int>, std::pair <int,int>>> list[MAXN];
std::pair <int,int> coords[10];
bool ranBruteforce = false;
bool isBanned[10][10];
bool isTaken[10];
int rotate[10];
int cnt;

std::vector <std::pair <int,int>> v;
std::vector <std::pair <int,int>> cpy;
std::vector <std::pair <std::pair <int,int>, std::pair <int,int>>> res;

void convert()
{
    res.clear();
    res.reserve(cpy.size());
    for (int i = 0 ; i < cpy.size() ; ++i)
    {
        res.push_back({coords[cpy[i].first], coords[cpy[i].second]});
    }
}

void do_rotate()
{
    for (int i = 0 ; i < cpy.size() ; ++i)
    {
        cpy[i] = {rotate[cpy[i].first], rotate[cpy[i].second]};
    }
}

void fix()
{
    for (int i = 0 ; i < cpy.size() ; ++i)
    {
        if (res[i].first.first > res[i].second.first)
        {
            std::swap(res[i].first, res[i].second);
        } else if (res[i].first.first == res[i].second.first && res[i].first.second < res[i].second.second)
        {
            std::swap(res[i].first, res[i].second);
        }
    }

    std::sort(res.begin(), res.end());
}

void rec(int idx)
{
    if (idx == 10)
    {
        cpy = v;
        convert();
        fix();

        if (map.count(res))
        {
            return;
        }

        cnt++;
        if (cnt > 1000)
        {
            return;
        }
        list[cnt] = res;
        map[res] = cnt;

        do_rotate();
        convert();
        fix();

        map[res] = cnt;

        do_rotate();
        convert();
        fix();
        
        map[res] = cnt;

        do_rotate();
        convert();
        fix();

        map[res] = cnt;
        return;
    }

    rec(idx + 1);
    if (isTaken[idx])
    {
        return;
    }

    for (int i = idx + 1 ; i <= 9 ; ++i)
    {
        if (!isTaken[i] && !isBanned[idx][i])
        {
            v.push_back({i, idx});
            isTaken[idx] = 1;
            rec(idx + 1);
            v.pop_back();
            isTaken[idx] = 0;
            if (cnt > 1000)
            {
                return;
            }
        }
    }
}

void run()
{
    coords[1] = {0, 2};
    coords[2] = {1, 2};
    coords[3] = {2, 2};
    coords[4] = {0, 1};
    coords[5] = {1, 1};
    coords[6] = {2, 1};
    coords[7] = {0, 0};
    coords[8] = {1, 0};
    coords[9] = {2, 0};
    isBanned[1][3] = 1;
    isBanned[1][7] = 1;
    isBanned[1][9] = 1;
    isBanned[3][7] = 1;
    isBanned[3][9] = 1;
    isBanned[7][9] = 1;
    rotate[1] = 7;
    rotate[2] = 4;
    rotate[3] = 1;
    rotate[4] = 8;
    rotate[5] = 5;
    rotate[6] = 2;
    rotate[7] = 9;
    rotate[8] = 6;
    rotate[9] = 3;
    ranBruteforce = true;
    rec(1);

    // std::cout << "made: " << cnt << " cards\n";
}

std::vector <std::pair <std::pair <int,int>, std::pair <int,int>>> mark_card (int idx) 
{
    if (!ranBruteforce)
    {
        run();
    }

    return list[idx];
}

int tell_card(std::vector <std::pair <std::pair <int,int>, std::pair <int,int>>> vector)
{
    if (!ranBruteforce)
    {
        run();
    }

    res = vector;
    fix();

    return map[res];
}
