#include <algorithm>
#include <iostream>
#include <cassert>
#include <vector>
#include <map>
#include <set>

#pragma GCC optimize ("O3")
#pragma GCC target ("sse4")

const int MAXN = 4e6 + 10;

std::map <std::vector <std::pair <std::pair <int,int>, std::pair <int,int>>>, int> map;
std::vector <std::pair <std::pair <int,int>, std::pair <int,int>>> list[MAXN];
std::pair <int,int> coords[10];
bool ranBruteforce = false;
bool isBanned[10][10];
bool isTaken[10];
int rotate[10];
int cnt;

std::vector <std::pair <int,int>> v;
std::vector <std::pair <int,int>> cpy;
std::vector <std::pair <std::pair <int,int>, std::pair <int,int>>> res;

void convert()
{
    res.clear();
    res.reserve(cpy.size());
    for (int i = 0 ; i < cpy.size() ; ++i)
    {
        res.push_back({coords[cpy[i].first], coords[cpy[i].second]});
    }
}

void do_rotate()
{
    for (int i = 0 ; i < cpy.size() ; ++i)
    {
        cpy[i] = {rotate[cpy[i].first], rotate[cpy[i].second]};
    }
}

void fix()
{
    for (int i = 0 ; i < cpy.size() ; ++i)
    {
        if (res[i].first.first > res[i].second.first)
        {
            std::swap(res[i].first, res[i].second);
        } else if (res[i].first.first == res[i].second.first && res[i].first.second < res[i].second.second)
        {
            std::swap(res[i].first, res[i].second);
        }
    }

    std::sort(res.begin(), res.end());
}

int pwr[15];
std::vector <std::pair <int,int>> byBit[15];
std::map <std::pair <int,int>, int> toIndex;
std::map <std::pair <int,int>, int> taken;
std::map <std::pair <int,int>, int> bit;
void run()
{
    coords[1] = {0, 2};
    coords[2] = {1, 2};
    coords[3] = {2, 2};
    coords[4] = {0, 1};
    coords[5] = {1, 1};
    coords[6] = {2, 1};
    coords[7] = {0, 0};
    coords[8] = {1, 0};
    coords[9] = {2, 0};

    for (int i = 1 ; i <= 9 ; ++i)
    {
        toIndex[coords[i]] = i;
    }

    isBanned[1][3] = 1;
    isBanned[1][7] = 1;
    isBanned[1][9] = 1;
    isBanned[3][7] = 1;
    isBanned[3][9] = 1;
    isBanned[7][9] = 1;
    isBanned[2][8] = 1;
    isBanned[4][6] = 1;
    rotate[1] = 7;
    rotate[2] = 4;
    rotate[3] = 1;
    rotate[4] = 8;
    rotate[5] = 5;
    rotate[6] = 2;
    rotate[7] = 9;
    rotate[8] = 6;
    rotate[9] = 3;
    ranBruteforce = true;

    int cnt = 0;
    for (int start = 1 ; start <= 9 ; ++start)
    {
        for (int end = start + 1 ; end <= 9 ; ++end)
        {
            int ss = start, ee = end;
            // std::cout << "try?: " << start << ' ' << end << ' ' << isBanned[start][end] << ' ' << taken.count({start, end}) << '\n';
            if (!isBanned[start][end] && !taken.count({start, end}))
            {
                // std::cout << "found for cnt: " << cnt << '\n' << std::flush;
                // std::cout << start << ' ' << end << '\n';
                byBit[cnt].push_back({start, end});
                taken[{start, end}] = cnt;
                taken[{end, start}] = cnt;
                bit[{start, end}] = 0;
                bit[{end, start}] = 0;

                start = rotate[start]; end = rotate[end];

                byBit[cnt].push_back({start, end});
                // std::cout << start << ' ' << end << '\n';
                taken[{start, end}] = cnt;
                taken[{end, start}] = cnt;
                bit[{start, end}] = 1;
                bit[{end, start}] = 1;

                start = rotate[start]; end = rotate[end];

                byBit[cnt].push_back({start, end});
                // std::cout << start << ' ' << end << '\n';
                taken[{start, end}] = cnt;
                taken[{end, start}] = cnt;
                bit[{start, end}] = 2;
                bit[{end, start}] = 2;

                start = rotate[start]; end = rotate[end];

                byBit[cnt].push_back({start, end});
                // std::cout << start << ' ' << end << '\n';
                taken[{start, end}] = cnt;
                taken[{end, start}] = cnt;
                bit[{start, end}] = 3;
                bit[{end, start}] = 3;

                cnt++;
            }

            start = ss;
            end = ee;
        }
    }

    pwr[0] = 1;
    for (int i = 1 ; i < 15 ; ++i)
    {
        pwr[i] = pwr[i - 1] * 16;
    }

    // std::cout << cnt << '\n' << std::flush;
    // rec(1);

    // std::cout << "made: " << cnt << " cards\n";
}

std::vector <std::pair <std::pair <int,int>, std::pair <int,int>>> mark_card (int n) 
{
    if (!ranBruteforce)
    {
        run();
    }

    std::vector <std::pair <std::pair <int,int>, std::pair <int,int>>> sol;
    for (int i = 0 ; i <= 6 ; ++i)
    {
        if (i == 6)
        {
            // std::cout << "n remainder: " << n << '\n';
            if (n == 0)
            {   
                sol.push_back({coords[byBit[i][0].first], coords[byBit[i][0].second]});
                continue;
            }

            if (n == 1)
            {   
                sol.push_back({coords[byBit[i][1].first], coords[byBit[i][1].second]});
                sol.push_back({coords[byBit[i][2].first], coords[byBit[i][2].second]});
                sol.push_back({coords[byBit[i][3].first], coords[byBit[i][3].second]});
                continue;
            }

            if (n == 2)
            {   
                sol.push_back({coords[byBit[i][0].first], coords[byBit[i][0].second]});
                sol.push_back({coords[byBit[i][1].first], coords[byBit[i][1].second]});
                continue;
            }

            sol.push_back({coords[byBit[i][0].first], coords[byBit[i][0].second]});
            sol.push_back({coords[byBit[i][2].first], coords[byBit[i][2].second]});
        }

        for (int j = 0 ; j < 4 ; ++j)
        {
            if ((n % 16) & (1 << j))
            {
                sol.push_back({coords[byBit[i][j].first], coords[byBit[i][j].second]});
            }
        }

        n /= 16;
    }

    return sol;
}

int tell_card(std::vector <std::pair <std::pair <int,int>, std::pair <int,int>>> vector)
{
    if (!ranBruteforce)
    {
        run();
    }

    res = vector;
    int cntRotations = -1;
    cpy.clear();

    for (int i = 0 ; i < vector.size() ; ++i)
    {
        cpy.push_back({toIndex[vector[i].first], toIndex[vector[i].second]});
    }

    std::vector <int> vals;
    for (int i = 0 ; i < cpy.size() ; ++i)
    {
        if (taken[cpy[i]] == 6)
        {
            vals.push_back(bit[cpy[i]]);
            // cntRotations = bit[cpy[i]];
            // break;
        }
    }

    int ans = 0;
    assert(vals.size());
    if (vals.size() == 1)
    {
        cntRotations = vals[0];
    } else if (vals.size() == 3)
    {
        cntRotations = vals[0] ^ vals[1] ^ vals[2];
    } else if (vals.size() == 2)
    {
        if (vals[0] > vals[1])
        {
            std::swap(vals[0], vals[1]);
        }

        if (vals[1] - vals[0] != 2)
        {
            ans += pwr[6] * 2;
            if (vals[0] == 0 && vals[1] == 3)
            {
                cntRotations = 3;
            } else
            {
                cntRotations = vals[0];
            }
        }
    }

    if (cntRotations != -1)
    {
        for (int i = 0 ; i < cpy.size() ; ++i)
        {
            int posBit = taken[cpy[i]];
            if (posBit == 6) continue;
            int value = bit[cpy[i]] - cntRotations;
            if (value < 0) value += 4;
            ans += pwr[posBit] * (1 << value);
        }

        return ans;
    }

    int ans1 = pwr[6] * 3;
    int ans2 = pwr[6] * 3;
    cntRotations = vals[0];

    for (int i = 0 ; i < cpy.size() ; ++i)
    {
        int posBit = taken[cpy[i]];
        if (posBit == 6) continue;
        int value = bit[cpy[i]] - cntRotations;
        if (value < 0) value += 4;
        ans1 += pwr[posBit] * (1 << value);
    }

    cntRotations = vals[1];
    for (int i = 0 ; i < cpy.size() ; ++i)
    {
        int posBit = taken[cpy[i]];
        if (posBit == 6) continue;
        int value = bit[cpy[i]] - cntRotations;
        if (value < 0) value += 4;
        ans2 += pwr[posBit] * (1 << value);
    }

    // std::cout << "here: " << ans1 << ' ' << ans2 << '\n';
    return std::max(ans1, ans2);
}
