#include <algorithm>
#include <iostream>
#include <cassert>
#include <vector>
#include <random>
#include <map>

bool ran;
bool success;
int first[1 << 13];
int second[1 << 13];
std::mt19937 rng(69420); //std::chrono::stadytime_since_epoch()
std::vector <int> v[1 << 13];
std::map <std::pair <std::pair <int,int>, std::pair <int,int>>, int> keys;

inline int get(int mask1, int mask2)
{
    return __builtin_ctz(((1 << 13) - 1) ^ mask1 ^ mask2);
}

std::pair <int,int> assistant1 (std::vector <int>& cards);
std::pair <int,int> assistant2 (std::vector <int>& cards);

void tryRun()
{
    ran = true;
    // while (!success)
    // {
        // std::cout << ".";
        keys.clear();
        for (int i = 0 ; i < (1 << 13) ; ++i)
        {
            v[i].clear();
            first[i] = second[i] = 0;
        }
        
        std::vector <int> masks;
        for (int mask = 0 ; mask < (1 << 13) ; ++mask)
        {
            if (__builtin_popcount(mask) != 6)
            {
                continue;
            }

            for (int i = 0 ; i < 13 ; ++i)
            {
                if (mask & (1 << i))
                {
                    v[mask].push_back(i);
                }
            }

            masks.push_back(mask);
            first[mask] = rng() % 6;
            second[mask] = rng() % (6 - 1);
            if (second[mask] >= first[mask]) second[mask]++;
        }


        success = true;
        for (const int &m1 : masks)
        {
            for (const int &m2 : masks)
            {
                if (m1 & m2)
                {
                    continue;
                }

                keys[{assistant1(v[m1]), assistant2(v[m2])}] = get(m1, m2);
            }
        }
    // }

    // std::cout << "success: " << success << "!\n";
}

std::pair <int,int> assistant1 (std::vector <int>& cards) 
{
    if (!ran) tryRun();
    // std::cout << "done run\n";
    int mask = 0;
    std::sort(cards.begin(), cards.end());
    for (const int &val : cards)
    {
        mask |= (1 << val);
    }

    assert(first[mask] != second[mask]);
    return {cards[first[mask]], cards[second[mask]]};
}

std::pair <int,int> assistant2 (std::vector <int>& cards) 
{
    int mask = 0;
    std::sort(cards.begin(), cards.end());
    for (const int &val : cards)
    {
        mask |= (1 << val);
    }

    return {cards[first[mask]], cards[second[mask]]};
}

int magician (int N, std::pair <int,int> chosen1, std::pair <int,int> chosen2)
{
    return keys[{chosen1, chosen2}];
}