#include <algorithm>
#include <iostream>
#include <numeric>
#include <cassert>
#include <vector>
#include <stack>
#include <set>

typedef long long llong;
const int MAXN = 100000 + 10;
const int MOD = 1e9 + 7;

int n, d;
struct Value
{
    int l, w;
    void fix()
    {
        if (l >= MOD) l -= MOD;
        if (w >= MOD) w -= MOD;
    }

    friend Value operator + (const Value &left, const Value &right)
    {
        Value result;
        result.l = left.l + right.l;
        result.w = left.w + right.w;
        result.fix();
        return result;
    }

    friend Value operator - (const Value &left, const Value &right)
    {
        Value result;
        result.l = left.l + MOD - right.l;
        result.w = left.w + MOD - right.w;
        result.fix();
        return result;
    }
};

int sz[MAXN];
bool win[MAXN];
Value dpW[MAXN];
Value dpL[MAXN];
Value coefsL, coefsW;
std::vector <int> g[MAXN];

void dfs(int node, int par)
{
    win[node] = false;
    for (const int &u : g[node])
    {
        if (u == par)
        {
            continue;
        }

        dfs(u, node);
        win[node] |= !win[u];
    }
}

void solve()
{
    int ans = 0;
    for (int u = 1 ; u <= n ; ++u)
    {
        for (int v = n + 1 ; v <= 2 * n ; ++v)
        {
            g[u].push_back(v);
            g[v].push_back(u);
            dfs(1, 0);
            ans += win[1];
            g[u].pop_back();
            g[v].pop_back();
        }
    }   
    
    std::cout << ans << '\n';
}

void input()
{
    std::cin >> n >> d;
    for (int i = 1 ; i < n ; ++i)
    {
        int u, v;
        std::cin >> u >> v;
        g[u].push_back(v);
        g[v].push_back(u);
        g[n + v].push_back(n + u);
        g[n + u].push_back(n + v);
    }
}

void fastIOI()
{
    std::ios_base :: sync_with_stdio(0);
    std::cout.tie(nullptr);
    std::cin.tie(nullptr);
}

int main()
{
    fastIOI();
    input();
    solve();

    return 0;
}