#include<bits/stdc++.h>
#define MAXN 150007
using namespace std;

int t,n,a,b;
long long m;
pair<int,int> c[MAXN],d[MAXN];
vector<int> v[MAXN],color[MAXN],dest[MAXN];

vector< pair<int,int> > tree[4*MAXN],queries[MAXN];

bool ok[MAXN],ban[MAXN];
int li[MAXN],tim;

struct event{
    int id,val,tim;
};

struct unionfind{
    int dsu[MAXN],sz[MAXN],cl;
    stack<event> st;

    void init(){
        for(int i=1;i<=n;i++){
            dsu[i]=i; sz[i]=1;
        }
    }

    int root(int x){
        if(dsu[x]==x)return x;
        return root(dsu[x]);
    }

    void mergev(int x,int y){
        int rootx=root(x);
        int rooty=root(y);

        cl++;
        if(rootx==rooty)return;

        if(sz[rootx]<sz[rooty])swap(rootx,rooty);

        st.push({rooty,dsu[rooty],cl});
        st.push({-rootx,sz[rootx],cl});

        dsu[rooty]=rootx;
        sz[rootx]+=sz[rooty];
    }

    void undo(){
        while(!st.empty() and st.top().tim==cl){
            if(st.top().id>0)dsu[st.top().id]=st.top().val;
            else sz[-st.top().id]=st.top().val;

            st.pop();
        }
        cl--;
    }
}graph;

void reset(){
    graph.init();

    for(int i=1;i<=n;i++){
        ok[i]=false;
        ban[i]=true;

        v[i].clear();

        dest[i].clear();
        color[i].clear();

        queries[i].clear();
    }

    for(int i=1;i<=4*n;i++){
        tree[i].clear();
    }
}

void dfs2(int x){
    li[x]=tim;
    
    for(int i:v[x]){
        if(li[i]==tim or ban[i])continue;
        dfs2(i);
    }
}

void update(int v,int l,int r,int ll,int rr,pair<int,int> e){
    if(ll>rr)return;
    if(l==ll and r==rr){
        tree[v].push_back(e);
    }else{
        int tt=(l+r)/2;
        update(2*v,l,tt,ll,min(tt,rr),e);
        update(2*v+1,tt+1,r,max(tt+1,ll),rr,e);
    }
}

void dfs(int v,int l,int r){
    for(pair<int,int> e:tree[v]){
        graph.mergev(e.first,e.second);
    }

    if(l==r){
        for(pair<int,int> s:queries[l]){
            if(!ok[s.first] and graph.root(s.first)==graph.root(s.second)){
                ok[s.first]=true;
            }
        }

        for(pair<int,int> e:tree[v]){
            graph.undo();
        }
        return;
    }

    int tt=(l+r)/2;
    dfs(2*v,l,tt);
    dfs(2*v+1,tt+1,r);

    for(pair<int,int> e:tree[v]){
        graph.undo();
    }
}

void solve(){
    cin>>n>>m;

    reset();

    for(int i=1;i<=n;i++){
        cin>>c[i].first;
        c[i].second=i;

        color[c[i].first].push_back(i);
    }
    for(int i=1;i<=n;i++){
        cin>>d[i].first;
        d[i].second=i;

        dest[d[i].first].push_back(i);
    }

    for(int i=1;i<=m;i++){
        cin>>a>>b;
        v[a].push_back(b);
        v[b].push_back(a);

        update(1,1,n,max(d[a].first,d[b].first),min(c[a].first,c[b].first),{a,b});
    }

    sort(c+1,c+n+1);
    sort(d+1,d+n+1);

    int pt=n;
    for(int i=n;i>=1;i--){
        while(pt>=1 and c[pt].first>=d[i].first){
            ban[c[pt].second]=false; pt--;
        }

        long long sz1=dest[d[i].first].size(),sz2=color[d[i].first].size();

        if( sz1 * sz2 > m){

            tim++;
            for(int k:color[d[i].first]){
                if(li[k]!=tim)dfs2(k);
            }

            for(int f:dest[d[i].first]){
                if(li[f]!=tim){
                    cout<<0<<"\n";
                    return;
                }

                ok[f]=true;
            }

        }else{

            for(int f:dest[d[i].first]){
                for(int k:color[d[i].first]){
                    queries[d[i].first].push_back({f,k});
                }
            }
        }

        for(int f=i;f>=1 and d[f].first==d[i].first;f--){
            ban[d[f].second]=true;
            i=f;
        }
    }

    dfs(1,1,n);

    for(int i=1;i<=n;i++){
        if(!ok[i]){
            cout<<0<<"\n";
            return;
        }
    }

    cout<<1<<"\n";
}

int main(){

    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);

    cin>>t;
    for(int i=1;i<=t;i++){
        solve();
    }

    return 0;
}